%{
/*
 $Id$

 */
#include "main.h"
int s;

void usage();
extern int yyparse(void);
%}

%option noyywrap

%%
\n				{ /* prevents \n being echoed */ }

^" "*HELO" ".*$	{ 
				/* tokenize the line, keep track of args */
				if (helo >= 1) {
                                        s = mod(rand(), 3);
                                        sleep(s);
					printf("already received helo.\n");
					break;
				}
				fprintf (stderr, "%s\n", yytext);
				s = mod(rand(), 15);
				sleep(s);
				printf("250 %s\n", hostname);
				helo += 1;
			}

^" "*MAIL" "FROM:" ".*$ 	{
				if (helo < 1) {
					s = mod(rand(), 3);
 	                                sleep(s);
					printf("500 Error: need HELO first.\n");
					break;
				}
				/* tokenize, keep track of args */
				fprintf (stderr, "%s\n", yytext);
				s = mod(rand(), 15);
                                sleep(s);
				printf("250 Ok\n");
				mailfrom += 1;
			}

^" "*RCPT" "TO:" ".*$ {
				if (helo < 1) {
                                        s = mod(rand(), 3);
					sleep(s);
					printf ("500 Error: need HELO first\n");
					break;
				}
				if (mailfrom < 1) {
                                        s = mod(rand(), 3);
                                        sleep(s);
					printf ("500 Error: need MAIL TO: first\n");
					break;
				}
				/* tokenize, handle args[1]->end */
				fprintf (stderr, "%s\n", yytext);
				s = mod(rand(), 15);
                                sleep(s);
				printf ("250 Ok\n");
				rcptto += 1;
			}

^" "*DATA" "*$ {
				if (helo < 1) {
                                        s = mod(rand(), 3);
                                        sleep(s);
                                        printf ("500 Error: need HELO first\n");
                                        break;
                                }
                                if (mailfrom < 1) {
                                        s = mod(rand(), 3);
                                        sleep(s);
                                        printf ("500 Error: need MAIL TO: first\n");
                                        break;
                                }
				if (rcptto < 1) {
                                        s = mod(rand(), 3);
                                        sleep(s);
					printf ("500 Error: need RCPT TO: first\n");
					break;
				}
				if (strlen(yytext) > 4) {
                                        s = mod(rand(), 3);
                                        sleep(s);
					printf ("500 Error: extra characters after DATA\n");
					break;
				}
				/* everything is A-OK */
				fprintf (stderr, "%s\n", yytext);
				s = mod(rand(), 15);
                                sleep(s);
				printf ("354 go ahead with message, use . to end\n");
				data += 1;
			}

^\." "*$			{
				if (data) {
					fprintf (stderr, "%s\n", yytext);
					s = mod(rand(), 5);
	                                sleep(s);
					printf ("250 Ok: queued as XXXX\n");
				}
			}

^" "*QUIT$	{
				fprintf (stderr, "%s\n", yytext);
				s = mod(rand(), 5);
                                sleep(s);
				printf ("221: Bye\n");
				exit (0);
			}
^" "*RSET$	{
				if (data) {
					break;
				}
				s = mod(rand(), 5);
                                sleep(s);
				data = 0;
				mailfrom = 0;
				rcptto = 0;
				printf ("250 Ok\n");
			}

^" "*EXPN" ".*$ {
				s = mod(rand(), 15);
                                sleep(s);
				printf ("502 Error: command not implemented\n");
				fprintf (stderr, "%s\n", yytext);
				break;
			}

^" "*VRFY" ".*$ {
				s = mod(rand(), 15);
                                sleep(s);
				printf ("502 Error: command not implemented\n");
				fprintf (stderr, "%s\n", yytext);
                                break;
			}

^.*$			{
				if (data < 1) {
					s = mod(rand(), 15);
	                                sleep(s);
					printf("500 Error: command not understood\n");
					break;
				}
				fprintf (stderr, "%s\n", yytext);
				data += 0;
				break;
			}


%%

int
main (int argc, char *argv[]) {	

	if (argc < 2) {
		printf ("you need to specify some arguments.\n");
		(void)usage();
	}

	strncpy (hostname, argv[argc - 1], sizeof(hostname));
	srand(time(NULL)^getpid());		/* XXX */

	sleep(mod(rand(), 10));
	printf ("220 %s SMTP Postfix\n", hostname);
	yyin = stdin;
	yylex ();
	return (1);
}

void
usage () {
	printf ("usage: esnail <hostname> ... \n");
	exit (-1);
}
